C----------------------------------------------------------------------------

C  Module name: PHIGS Debugger.

C  Author: Steve Larkin.

C  Function: This module contains the PHIGS Debugger.

C  Dependencies:

C  Internal function list: 

C  External function list: 

C  Modification history: (Version), (Date), (name), (Description).

C  1.0, 23rd August 1988, S. Larkin, First version.

C  2.0, 30th October 1991, G. Williams, Translated to C.

C----------------------------------------------------------------------------

        SUBROUTINE ptkf_debugger(wsid, stid)
C /*
C ** \parambegin
C ** \param{INTEGER}{wsid}{workstation identifier}{IN}
C ** \param{INTEGER}{stid}{structure identifier}{IN}
C ** \paramend
C ** \blurb{This function starts the PHIGS debugger on workstation
C ** \pardesc{wsid}, and makes structure \pardesc{stid} the root of the structure network
C ** to be debugged.}
C */
        INTEGER wsid, stid
        external ptk_debugger !$PRAGMA C(ptk_debugger)

        call ptk_debugger(%val(wsid), %val(stid))
 
        RETURN
        END

        SUBROUTINE ptkf_setdebuggerattrs(menufont, windowfont,
& menucol, menutextcol, windowcol, 
& bannercol, bannertextcol, tlcol, brcol, arrowcol, arrowedgecol)
C /*
C ** \parambegin
C ** \param{INTEGER}{menufont}{menu text font}{IN}
C ** \param{INTEGER}{windowfont}{window text font}{IN}
C ** \param{INTEGER}{menucol}{menu colour index}{IN}
C ** \param{INTEGER}{menutextcol}{menu text colour index}{IN}
C ** \param{INTEGER}{windowcol}{window interior colour index}{IN}
C ** \param{INTEGER}{bannercol}{window banner colour index}{IN}
C ** \param{INTEGER}{bannertextcol}{window banner text colour index}{IN}
C ** \param{INTEGER}{tlcol}{top-left colour index}{IN}
C ** \param{INTEGER}{brcol}{bottom-right colour index}{IN}
C ** \param{INTEGER}{arrowcol}{arrow colour index}{IN}
C ** \param{INTEGER}{arrowedgecol}{arrow edge colour index}{IN}
C ** \paramend
C ** \blurb{This function enables an application to set
C **  the fonts and colours of menus and windows in the PHIGS debugger.}
C */
	INTEGER menufont, windowfont
	INTEGER menucol, menutextcol, windowcol
        INTEGER bannercol, bannertextcol, tlcol, brcol
	INTEGER arrowcol, arrowedgecol
        external ptk_setdebuggerattrs !$PRAGMA C(ptk_setdebuggerattrs)

 	call ptk_setdebuggerattrs(%val(menufont), %val(windowfont),
& %val(menucol), %val(menutextcol), 
& %val(windowcol), %val(bannercol), %val(bannertextcol), %val(tlcol),
& %val(brcol), %val(arrowcol), %val(arrowedgecol))

	RETURN
	END

        SUBROUTINE ptkf_inqdebuggerattrs(menufont, windowfont,
& menucol, menutextcol, windowcol, 
& bannercol, bannertextcol, tlcol, brcol, arrowcol, arrowedgecol)
C /*
C ** \parambegin
C ** \param{INTEGER}{menufont}{menu text font}{IN}
C ** \param{INTEGER}{windowfont}{window text font}{IN}
C ** \param{INTEGER}{menucol}{menu colour index}{IN}
C ** \param{INTEGER}{menutextcol}{menu text colour index}{IN}
C ** \param{INTEGER}{windowcol}{window interior colour index}{IN}
C ** \param{INTEGER}{bannercol}{window banner colour index}{IN}
C ** \param{INTEGER}{bannertextcol}{window banner text colour index}{IN}
C ** \param{INTEGER}{tlcol}{top-left colour index}{IN}
C ** \param{INTEGER}{brcol}{bottom-right colour index}{IN}
C ** \param{INTEGER}{arrowcol}{arrow colour index}{IN}
C ** \param{INTEGER}{arrowedgecol}{arrow edge colour index}{IN}
C ** \paramend
C ** \blurb{This function may be used to obtain the text font and 
C ** colour attribute values of menus and windows used in the PHIGS debugger.}
C */
	INTEGER menufont, windowfont
	INTEGER menucol, menutextcol, windowcol
        INTEGER bannercol, bannertextcol, tlcol, brcol
	INTEGER arrowcol, arrowedgecol
        external ptk_inqdebuggerattrs !$PRAGMA C(ptk_inqdebuggerattrs)

 	call ptk_inqdebuggerattrs(menufont, windowfont,
& menucol, menutextcol, 
& windowcol, bannercol, bannertextcol, tlcol,
& brcol, arrowcol, arrowedgecol)

	RETURN
	END

C end of debug.f
