/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <math.h>
#include <phigs.h>
#include "ptk.h"

/*--------------------------------------------------------------------------*/
/*-------------------------- returning reals -------------------------------*/

extern FLOATFUNCTIONTYPE ptkc_readfloat(ws, defreal, prompt, echoarea)
Pint ws;
Pfloat defreal;
char *prompt;
Plimit *echoarea;
{
  RETURNFLOAT(ptk_readfloat(ws, defreal, prompt, echoarea));
}  /* ptkc_readfloat */

/*--------------------------------------------------------------------------*/
/*---------------------- variable length arrays ----------------------------*/

extern ptkboolean ptkc_pickscanmenus(ippd, pp, ppordr, menuid, itemnum)
Pint ippd;
Ppick_path_elem *pp;
Pint ppordr;
Pint *menuid, *itemnum;
{
  Ppick_path pickpath;
  Pint i;
  ptkboolean result;

  pickpath.depth = ippd;
  pickpath.path_list = pp;
  result = ptk_pickscanmenus(&pickpath, ppordr, menuid, itemnum);
  free(pickpath.path_list);
  return result;
}  /* ptkc_pickscanmenus */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqpostedmenus(wsid, num, menuids, totalnum, err)
Pint wsid, num, *menuids, *totalnum, *err;
{
  Pint_list menuidlst;

  menuidlst.num_ints = num;
  menuidlst.ints = menuids;
  ptk_inqpostedmenus(wsid, num, &menuidlst, totalnum, err);
}  /* ptkc_inqpostedmenus */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqmenuids(num, menuids, totalnum, err)
Pint num, *menuids, *totalnum, *err;
{
  Pint_list menuidlst;

  menuidlst.num_ints = num;
  menuidlst.ints = menuids;
  ptk_inqmenuids(num, &menuidlst, totalnum, err);
}  /* ptk_inqmenuids */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqpostedtopologies(wsid, num, topids, totalnum)
Pint wsid, num, *topids, *totalnum;
{
  Pint_list topidlst;

  topidlst.num_ints = num;
  topidlst.ints = topids;
  ptk_inqpostedtopologies(wsid, num, &topidlst, totalnum);
}  /* ptkc_inqpostedtopologies */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqtopologyids(num, topids, totalnum)
Pint num, *topids, *totalnum;
{
  Pint_list topidlst;

  topidlst.num_ints = num;
  topidlst.ints = topids;
  ptk_inqtopologyids(num, &topidlst, totalnum);
}  /* ptk_inqtopologyids */

/*--------------------------------------------------------------------------*/

extern void ptkc_writestruct(fileptr, num, stids)
FILE *fileptr;
Pint num, *stids;
{
  Pint_list stidlst;

  stidlst.num_ints = num;
  stidlst.ints = stids;
  ptk_writestruct(fileptr, &stidlst);
}  /* ptkc_writestruct */

/*--------------------------------------------------------------------------*/

extern void ptkc_writestructnet(fileptr, num, stids)
FILE *fileptr;
Pint num, *stids;
{
  Pint_list stidlst;

  stidlst.num_ints = num;
  stidlst.ints = stids;
  ptk_writestructnet(fileptr, &stidlst);
}  /* ptkc_writestructnet */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqpostedwindows(wsid, num, windowids, totalnum)
Pint wsid, num, *windowids, *totalnum;
{
  Pint_list windidlst;

  windidlst.num_ints = num;
  windidlst.ints = windowids;
  ptk_inqpostedwindows(wsid, num, &windidlst, totalnum);
}  /* ptkc_inqpostedwindows */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqwindowids(num, windowids, totalnum)
Pint num, *windowids, *totalnum;
{
  Pint_list windidlst;

  windidlst.num_ints = num;
  windidlst.ints = windowids;
  ptk_inqwindowids(num, &windidlst, totalnum);
}  /* ptkc_inqwindowids */

/*--------------------------------------------------------------------------*/

extern void ptkc_setcameraworld(windid, num, stids)
Pint windid, num, *stids;
{
  Pint_list stidlst;
 
  stidlst.num_ints = num;
  stidlst.ints = stids;
  ptk_setcameraworld(windid, &stidlst);
}  /* ptkc_setcameraworld */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqwindowviewrep(windid, vwormt,
  vwmpmt, vwcplm, xyclpi, bclipi, fclipi, err)
Pint windid;
Pmatrix3 vwormt, vwmpmt;
Plimit3 *vwcplm;
Pint *xyclpi, *bclipi, *fclipi, *err;
{
  Pview_rep3 rep;

  ptk_inqwindowviewrep(windid, &rep, err);
  memcpy(vwormt, rep.ori_matrix, sizeof(Pmatrix3));
  memcpy(vwmpmt, rep.map_matrix, sizeof(Pmatrix3));
  *vwcplm = rep.clip_limit;
  *xyclpi = rep.xy_clip;
  *bclipi = rep.back_clip;
  *fclipi = rep.front_clip;
}  /* ptkc_inqwindowviewrep */

/*--------------------------------------------------------------------------*/

extern void ptkc_vieweditor(wsid, num, stids, vwormt, vwmpmt, 
                            vwcplm, xyclpi, bclipi, fclipi)
Pint wsid, num, *stids;
Pmatrix3 vwormt, vwmpmt;
Plimit3 *vwcplm;
Pint *xyclpi, *bclipi, *fclipi;
{
  Pint_list stidlst;
  Pview_rep3 vrep;

  stidlst.num_ints = num;
  stidlst.ints = stids;
  ptk_vieweditor(wsid, &stidlst, &vrep);
  memcpy(vwormt, vrep.ori_matrix, sizeof(Pmatrix3));
  memcpy(vwmpmt, vrep.map_matrix, sizeof(Pmatrix3));
  *vwcplm = vrep.clip_limit;
  *xyclpi = vrep.xy_clip;
  *bclipi = vrep.back_clip;
  *fclipi = vrep.front_clip;
}  /* ptkc_vieweditor */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqstructnetids(structid, num, ids, totalnum)
Pint structid, num, *ids, *totalnum;
{
  Pint_list idlst;

  idlst.num_ints = num;
  idlst.ints = ids;
  ptk_inqstructnetids(structid, num, &idlst, totalnum);
}  /* ptkc_inqstructnetids */

/*--------------------------------------------------------------------------*/

extern void ptkc_inqtslnameset(num, nameset, totalnum)
Pint num, *nameset, *totalnum;
{
  Pint_list names;

  names.num_ints = num;
  names.ints = nameset;
  ptk_inqtslnameset(num, &names, totalnum);
}  /* ptkc_inqtslnameset */

/*--------------------------------------------------------------------------*/

extern FILE * ptkc_fopen(filename, type)
char *filename, *type;
{
  FILE *temp;

  temp = fopen(filename, type);
  return temp;
}  /* ptkc_fopen */

/*--------------------------------------------------------------------------*/

extern Pint ptkc_fclose(fileptr)
FILE *fileptr;
{
  return fclose(fileptr);
}  /* ptkc_fclose */

/*--------------------------------------------------------------------------*/

extern void ptkc_openfile(filename, type, fileptr)
char *filename;
char *type;
FILE **fileptr;
{
  if (strncmp(filename, "stdout", 6) == 0)
    *fileptr = stdout;
  else
  if (strncmp(filename, "stdin", 5) == 0)
    *fileptr = stdout;
  else
  if (strncmp(filename, "stderr", 6) == 0)
    *fileptr = stderr;
  else
  *fileptr = fopen(filename, type);
}  /* ptkc_openfile */

/*--------------------------------------------------------------------------*/

extern void ptkc_closefile(filename, fileptr)
char *filename;
FILE **fileptr;
{
  if ((strncmp(filename, "stdout", 6) != 0) &&
      (strncmp(filename, "stdin", 5) != 0) &&
      (strncmp(filename, "stderr", 6) != 0))
    fclose(*fileptr);
}  /* ptkc_closefile */

/*--------------------------------------------------------------------------*/

/* end of ftoc.c */

